//+------------------------------------------------------------------+
//|                            Symphonie Spikes aka SuperSignal.mq4  |
//|                 Copyright 2006, Nick Bilak, beluck[AT]gmail.com  |
//|                               Modified by mtuppers[AT]gmail.com  |
//|			                            took away time, add periods  |
//|   Modified by MaryJane: histogram version a-la Cycle Identifier 
//|   modified by milanese for showing crrect a HigherUserTF
//+------------------------------------------------------------------+

#property indicator_separate_window
#property indicator_minimum -1.2
#property indicator_maximum 1.2
#property indicator_buffers 5
#property indicator_color1 DarkGray
#property indicator_color2 Red
#property indicator_color3 DodgerBlue
#property indicator_color4 White
#property indicator_color5 White
#property indicator_width1 2
#property indicator_width2 3
#property indicator_width3 3
#property indicator_width4 1
#property indicator_width5 1

//input properties
extern string   UseSymbol="";
extern string UniqueID="SymphonieSpikesOne";
extern int  UserTF=PERIOD_H1;
extern int  dist2           = 48;
extern int  dist1           = 32;
extern bool alertsOn        = true;
extern string note1 = "alert all = 0",
              note2 = "buy only = 1, sell only = 2",
              note3 = "extreme buy or extreme sell = 3";
extern int  alertsOption    = 3;
extern bool alertsOnCurrent = true;
extern bool alertsMessage   = true;
extern bool alertsSound     = true;
extern bool alertsEmail     = false;

double b1[];
double b2[];
double b3[];
double b4[];
double b5[];
string shortName;

int init()
{
   SetIndexBuffer(0,b1);
   SetIndexBuffer(1,b2);
   SetIndexBuffer(2,b3);
   SetIndexBuffer(3,b4);
   SetIndexBuffer(4,b5);
   SetIndexStyle(0,DRAW_LINE);
   if (UseSymbol=="") UseSymbol=Symbol();
   if ( UserTF< Period()) 
     {
     Alert ("UserTF can not be < as used TF!!");
     Alert ("User TF set to used TF");
     UserTF = Period();
     }  
   for (int i=1; i<5; i++) {SetIndexStyle(i,DRAW_HISTOGRAM);}
   for (i=0; i<5; i++) {SetIndexLabel(i,NULL);}
   shortName = UseSymbol+" "+UserTF+" "+UniqueID;
   IndicatorShortName(shortName);
   return(0);
}
int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit,hhb,llb,hhb1,llb1;

   if(counted_bars<0) return(-1);
   limit=Bars-counted_bars+UserTF/Period();
    
   datetime TimeArray1[];
   int y1=0;
    ArrayCopySeries(TimeArray1,MODE_TIME,UseSymbol,UserTF);

  for(i=0,y1=0;i<limit;i++)

     {
        if(Time[i]<TimeArray1[y1]) y1++;
         hhb1 = Highest(UseSymbol,UserTF,MODE_HIGH,dist1,y1-dist1/2);
         llb1 = Lowest(UseSymbol,UserTF,MODE_LOW,dist1,y1-dist1/2);
         hhb  = Highest(UseSymbol,UserTF,MODE_HIGH,dist2,y1-dist2/2);
         llb  = Lowest(UseSymbol,UserTF,MODE_LOW,dist2,y1-dist2/2);

         b1[i] = 0;
         b2[i] = EMPTY_VALUE;
         b3[i] = EMPTY_VALUE;
         b4[i] = EMPTY_VALUE;
         b5[i] = EMPTY_VALUE;
      
         if (i==hhb)  {b2[i]=1; b1[i]=1;}
         if (i==llb)  {b3[i]=-1; b1[i]=-1;}
         if (i==hhb1) {b4[i]=1; b1[i]=1;}
         if (i==llb1) {b5[i]=-1; b1[i]=-1;}
      }
      
   //
   //
   //
   //
   //
   
   if (alertsOn)
      {
         int forBar = 1;
         if (alertsOnCurrent) forBar = 0;
         if (alertsOption == 0)  //alert on all direction
            {
            if (b2[forBar] != EMPTY_VALUE && b4[forBar] != EMPTY_VALUE) doAlert("extreme sell");
            if (b2[forBar] != EMPTY_VALUE && b4[forBar] == EMPTY_VALUE) doAlert("sell");
            if (b2[forBar] == EMPTY_VALUE && b4[forBar] != EMPTY_VALUE) doAlert("minor sell or exit buy");
            if (b3[forBar] != EMPTY_VALUE && b5[forBar] != EMPTY_VALUE) doAlert("extreme buy");
            if (b3[forBar] != EMPTY_VALUE && b5[forBar] == EMPTY_VALUE) doAlert("buy");
            if (b3[forBar] == EMPTY_VALUE && b5[forBar] != EMPTY_VALUE) doAlert("minor buy or exit sell");
            }
         if (alertsOption == 1)  //alert on buy only
            {
            if (b3[forBar] != EMPTY_VALUE && b5[forBar] != EMPTY_VALUE) doAlert("extreme buy");
            if (b3[forBar] != EMPTY_VALUE && b5[forBar] == EMPTY_VALUE) doAlert("buy");
            if (b3[forBar] == EMPTY_VALUE && b5[forBar] != EMPTY_VALUE) doAlert("minor buy or exit sell");
            }
         if (alertsOption == 2)  //alert on sell only
            {
            if (b2[forBar] != EMPTY_VALUE && b4[forBar] != EMPTY_VALUE) doAlert("extreme sell");
            if (b2[forBar] != EMPTY_VALUE && b4[forBar] == EMPTY_VALUE) doAlert("sell");
            if (b2[forBar] == EMPTY_VALUE && b4[forBar] != EMPTY_VALUE) doAlert("minor sell or exit buy");
            }
         if (alertsOption == 3)  //alert on extreme buy or sell
            {
            if (b3[forBar] != EMPTY_VALUE && b5[forBar] != EMPTY_VALUE) doAlert("extreme buy");
            if (b2[forBar] != EMPTY_VALUE && b4[forBar] != EMPTY_VALUE) doAlert("extreme sell");
            }
      }
      
  return(0);
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   string TimePeriod;
   
   if (UserTF== 1)       TimePeriod = "1 MIN";
   if (UserTF== 5)       TimePeriod = "5 MIN";
   if (UserTF== 15)      TimePeriod = "15 MIN";
   if (UserTF== 30)      TimePeriod = "30 MIN";
   if (UserTF== 60)      TimePeriod = "1 HR";
   if (UserTF== 240)     TimePeriod = "4 HR";
   if (UserTF== 1440)    TimePeriod = "DAILY";
   if (UserTF== 10080)   TimePeriod = "WEEKLY";
   if (UserTF== 43200)   TimePeriod = "MONTHLY";

      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(UseSymbol," at ", TimePeriod, " Symphonie Spike : ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(UseSymbol,"Symphonie Spike "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}